uniform sampler2DRect imgMap;

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

	//horizontal gaussian convolution
	vec4 imgGG = texture2DRect(imgMap,pixCoord-vec2(2,0));
        vec4 imgG = texture2DRect(imgMap,pixCoord-vec2(1,0));
        vec4 img = texture2DRect(imgMap,pixCoord);
	vec4 imgD = texture2DRect(imgMap,pixCoord+vec2(1,0));
        vec4 imgDD = texture2DRect(imgMap,pixCoord+vec2(2,0));


	gl_FragColor = 0.0545*imgGG
                        +0.2442*imgG
                        +0.4026*img
                        +0.2442*imgD
                        +0.0545*imgDD;
}
