uniform sampler2DRect gxMap, gyMap;

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

	//div = dgx/dx + dgy/dy
        vec4 gxG = texture2DRect(gxMap,pixCoord-vec2(1,0));
	vec4 gxD = texture2DRect(gxMap,pixCoord+vec2(1,0));
	vec4 gyH = texture2DRect(gyMap,pixCoord-vec2(0,1));
	vec4 gyB = texture2DRect(gyMap,pixCoord+vec2(0,1));


	gl_FragColor = vec4(0.5,0.5,0.5,1)+0.5*(gxG-gxD+gyH-gyB);
}
