//this shader is not currently used. See jacobi_poisson

uniform sampler2DRect imgMap;//,divMap;
uniform float scale;
//scale corresponds to the scaling factor when accessing to
//the result of a coarser level in the multigrid

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

        //Jacobi iteration
        vec4 imgG = texture2DRect(imgMap,scale*pixCoord+vec2(-1,0));
	vec4 imgD = texture2DRect(imgMap,scale*pixCoord+vec2(1,0));
	vec4 imgH = texture2DRect(imgMap,scale*pixCoord+vec2(0,-1));
	vec4 imgB = texture2DRect(imgMap,scale*pixCoord+vec2(0,1));
        //vec4 div = 2.0*(texture2DRect(divMap,pixCoord)-vec4(0.5,0.5,0.5,1));

        //vec4 relax = 0.25*(div+imgG+imgD+imgH+imgB);

        //get alpha values
        imgG[3]=2.0*(imgG[3]-0.5);
        imgD[3]=2.0*(imgD[3]-0.5);
        imgH[3]=2.0*(imgH[3]-0.5);
        imgB[3]=2.0*(imgB[3]-0.5);
        float norm = imgG[3]+imgD[3]+imgH[3]+imgB[3];

        //premultiply alpha
        imgG = imgG*vec4(imgG[3],imgG[3],imgG[3],imgG[3]);
        imgD = imgD*vec4(imgD[3],imgD[3],imgD[3],imgD[3]);
        imgH = imgH*vec4(imgH[3],imgH[3],imgH[3],imgH[3]);
        imgB = imgB*vec4(imgB[3],imgB[3],imgB[3],imgB[3]);

        if(norm<0.02){
            norm = 4;
        }
        vec4 relax = (imgG+imgD+imgH+imgB)/norm;
        relax[3] = 0.5 + 0.5*relax[3];
        
        //clamp(relax,vec4(0,0,0,1),vec4(1,1,1,1));

	gl_FragColor = relax;
}
