uniform sampler2DRect imgMap;

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

        //restriction
        vec4 imgG = texture2DRect(imgMap,2.0*pixCoord+vec2(-1,0))-vec4(0.5,0.5,0.5,1);
	vec4 imgD = texture2DRect(imgMap,2.0*pixCoord+vec2(1,0))-vec4(0.5,0.5,0.5,1);
	vec4 imgH = texture2DRect(imgMap,2.0*pixCoord+vec2(0,-1))-vec4(0.5,0.5,0.5,1);
	vec4 imgB = texture2DRect(imgMap,2.0*pixCoord+vec2(0,1))-vec4(0.5,0.5,0.5,1);

        vec4 imgGH = texture2DRect(imgMap,2.0*pixCoord+vec2(-1,-1))-vec4(0.5,0.5,0.5,1);
	vec4 imgDH = texture2DRect(imgMap,2.0*pixCoord+vec2(1,-1))-vec4(0.5,0.5,0.5,1);
	vec4 imgGB = texture2DRect(imgMap,2.0*pixCoord+vec2(-1,1))-vec4(0.5,0.5,0.5,1);
	vec4 imgDB = texture2DRect(imgMap,2.0*pixCoord+vec2(1,1))-vec4(0.5,0.5,0.5,1);

        vec4 imgC = texture2DRect(imgMap,2.0*pixCoord)-vec4(0.5,0.5,0.5,1);

	gl_FragColor = vec4(0.5,0.5,0.5,1)+0.5*imgC+(imgG+imgD+imgH+imgB)/4.0+(imgGH+imgDH+imgGB+imgDB)/8.0;
}
