//defines global parameters
#ifndef _GLOBAL_PARAM
#define _GLOBAL_PARAM

//blur
#define MAX_BLUR 16
//lifetime
#define MAX_LIFETIME 32
//domain size
#define GRID_SIZE 512
#define PI 3.14159265
//set color
const float controlPointsColor[] = {0.f, 0.f, 0.9f};
const float tangentPointsColor[] = {1.f, 1.f, 0.f};
const float boundingBoxColor[] = {0.f, 0.f, 0.f};
const float splineColor[] = {0.f, 0.f, 0.f};
const float mouseSelectColor[] = {1.f,  0.521f, 0.121f, 0.3f};
const int leftColorInit[] = {255,255,255};
const int rightColorInit[] = {130, 25, 25};
//const int leftColorInit[] = {128,128,128};
//const int rightColorInit[] = {128, 128, 128};
const int bucketColorInit[] = {130, 210, 25};


enum ManipulationMode {ManipMode_SELECT_ONE_GEOMETRY, ManipMode_SELECT_ONE_REDRAW, ManipMode_SELECT_ONE_ATTRIB,
ManipMode_SELECT_MULTI, ManipMode_DRAW_CATMULL, ManipMode_DRAW_LINE, 
ManipMode_PAN, ManipMode_DISABLED, ManipMode_BUCKET, ManipMode_PICKER};
enum ClickType {ClickType_LEFT_BUTTON, ClickType_RIGHT_BUTTON, ClickType_SHIFT_LEFT, ClickType_CTRL_LEFT};
enum AttribType {COLOR_LEFT, COLOR_RIGHT, BLUR};
enum DisplayMode {displayRESULT, displayCOLOR_CONSTRAINTS, displayBLUR_CONSTRAINTS, displayBLUR_MAP, displayNOTHING,
        displayGX, displayGY};

#endif
