uniform sampler2DRect gradMap, blurMap;
uniform float lowT,highT;

void main()
{
    vec2 pixCoord = gl_FragCoord.xy;

    vec4 grad = texture2DRect(gradMap,pixCoord);
    vec4 blur = texture2DRect(blurMap,pixCoord);

    gl_FragColor = vec4(0.5,0.5,0.5,1);

    if(blur[0]>=lowT && blur[0]<highT)
        gl_FragColor = grad;
}
