uniform sampler2DRect imgMap;

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

	//vertical gaussian convolution
	vec4 imgHH = texture2DRect(imgMap,pixCoord-vec2(0,2));
        vec4 imgH = texture2DRect(imgMap,pixCoord-vec2(0,1));
        vec4 img = texture2DRect(imgMap,pixCoord);
	vec4 imgB = texture2DRect(imgMap,pixCoord+vec2(0,1));
        vec4 imgBB = texture2DRect(imgMap,pixCoord+vec2(0,2));


	gl_FragColor = 0.0545*imgHH
                        +0.2442*imgH
                        +0.4026*img
                        +0.2442*imgB
                        +0.0545*imgBB;
}
