uniform sampler2DRect imgMap;

void main()
{
	vec2 pixCoord = gl_FragCoord.xy;

        int i,j;
        vec4 sum = vec4(0,0,0,0);
        vec4 img;
        int nbFrags = 0;
        for(i=-1;i<=1;i++){
            for(j=-1;j<=1;j++){
                img = texture2DRect(imgMap,2.0*pixCoord+vec2(i,j));
                if(img[3]>0.1){
                    sum+=img;
                    nbFrags+=1;
                }
            }
        }

        if(nbFrags>0){
            sum = sum/float(nbFrags);
            sum[3] = 1.0;
        }
        else{
            sum=vec4(0.0,0.0,0.0,0.0);
        }

	gl_FragColor = sum;
}
